#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include<time.h>


#define INF 9999
#define MAX_NOEUD 6

/* Structure de file et fonctions */
typedef struct element {
    int valeur;
    struct element *suivant;
}element;


typedef struct file{
  element *debut;
  element *fin;
  int taille;
} file;

int is_empty_file(file *F){
    if (F->taille == 0 && F->debut == NULL && F->fin == NULL)
        return 1;
    else
        return 0;
}

file * newfile() {
   file *F = malloc(sizeof(*F));
   if (F == NULL) printf("Erreur d'allocation.");
   F->taille = 0;
   F->debut = F->fin = NULL;
   return(F);
}

void push(file *F, int s) {
    if (F == NULL) printf ("La file n'existe pas - On ne peut empiler.");
    element *e = malloc(sizeof(*e));
    if (e == NULL)
        printf("Erreur d'allocation");
    e->valeur = s;
    e->suivant = NULL;
    if (F->taille == 0){
        F->debut = F->fin = e;
    }
    else {
        F->fin->suivant = e;
        F->fin = e;
        }
    (F->taille)+=1;
}

void defiler(file *F) {
    element *e = malloc(sizeof(*e));
    if (F == NULL || F->taille == 0)printf("Erreur dépilement.");
        e = F->debut;
    if (F->taille == 1)
        F->debut = F->fin = NULL;
    else
        F->debut= F->debut->suivant;
   F->taille -= 1;
}

int take_first(file *F){
    if (is_empty_file(F) == 1){
        printf("La file est vide. Pas de première valeur.");
        return 0;
        }
    else
        return F->debut->valeur;
}

int take_last(file *F){
    if (is_empty_file(F) == 1){
        printf("La file est vide. Pas de première valeur.");
        return 0;
        }
    else
        return F->fin->valeur;
}

/* Affichage d'une file */
void affiche_file(file *F) {
   element *e;
   if (F == NULL) printf("Erreur; pas d'affichage possible. \n");
   e = F->debut;
   while (e != NULL) {
      printf("%d ", e->valeur);
      e = e->suivant;
   }
   printf("\n");
}


/* Structure de tas et fonctions utilisées */
typedef enum
{
    false,
    true
} bool;

typedef struct noeudTas
{
    int  v;
    int dist;
} noeudTas;

typedef struct Tas
{
    int size;
    int capacity;
    int *pos;
    struct noeudTas **array;
} Tas;


noeudTas * new_noeudTas(int v, int dist){
    noeudTas *node = malloc(sizeof(*node));
    node->v = v;
    node->dist = dist;
    return node;
}

Tas * creer_tas(int n)
{
    Tas *tas = malloc(sizeof(*tas));
    tas->pos = (int *) malloc(n * sizeof(int));
    tas->size = 0;
    tas->capacity = n;
    tas->array = malloc(n *sizeof(noeudTas*));
    return tas;
}

void echange_noeud(noeudTas **a, noeudTas **b)
{
    noeudTas * t = *a;
    *a = *b;
    *b = t;
}


/* Une fonction pour entasser un noeud dans un tas */
void entasser(Tas* tas, int idx)
{
    int smallest, left, right;
    smallest = idx;
    left = 2 * idx + 1;
    right = 2 * idx + 2;
    if (left < tas->size &&
        tas->array[left]->dist < tas->array[smallest]->dist)
        smallest = left;

    if (right < tas->size &&
        tas->array[right]->dist <tas->array[smallest]->dist )
        smallest = right;

    if (smallest != idx)
    {
        noeudTas *smnode = tas->array[smallest];
        noeudTas *idxnode = tas->array[idx];
        tas->pos[smnode->v] = idx;
        tas->pos[idxnode->v] = smallest;
        echange_noeud(&tas->array[smallest], &tas->array[idx]);
        entasser(tas, smallest);
    }
}

int is_empty_tas(struct Tas* tas)
{
    return tas->size == 0;
}

/* Fonction pour extraire le minimum d'un tas */
noeudTas* extract_min(Tas* tas)
{
    if (tas -> size == 0)
        return NULL;
    noeudTas* root = tas->array[0];
    noeudTas* lastnode = tas->array[tas->size - 1];
    tas->array[0] = lastnode;
    tas->pos[root->v] = tas->size-1;
    tas->pos[lastnode->v] = 0;
    tas->size -= 1;
    entasser(tas, 0);
    return root;
}

/* Fonction pour diminuer la valeur d'un certain noeud */
void decrease_value(struct Tas* tas, int v, int dist)
{
    int i = tas->pos[v];
    tas->array[i]->dist = dist;
    while (i && tas->array[i]->dist <
           tas->array[(i - 1) / 2]->dist)
    {
        tas->pos[tas->array[i]->v] =
                                      (i-1)/2;
        tas->pos[tas->array[
                             (i-1)/2]->v] = i;
        echange_noeud(&tas->array[i],
                 &tas->array[(i - 1) / 2]);
        i = (i - 1) / 2;
    }
}

bool appartient_tas(Tas *tas, int v)
{
   if (tas->pos[v] < tas->size)
     return true;
   return false;
}

/* Structure de liste d'adjacence */
typedef struct nodeAdjList
{
    int target;
    int weight;
    struct nodeAdjList* next;
} nodeAdjList;


typedef struct AdjList
{
   struct nodeAdjList* head;
   } AdjList;

int is_empty_adjlist(AdjList L)
{
    return L.head == NULL;
}

typedef struct graphe
{
    int vertices;
    struct AdjList* array;
} graphe;


/* Crée un noeud de liste d'adjacence */
nodeAdjList * new_nodeAdjList(int target, int weight){
    nodeAdjList *noeud = malloc(sizeof(*noeud));
    noeud->target = target;
    noeud->weight = weight;
    noeud->next = NULL;
    return noeud;
}

/* Fonction qui crée un graphe vide à n sommets. */
graphe * newgraph(int n)
{
    graphe *grph = malloc(sizeof(*grph));
    grph->vertices = n;
    grph->array = (AdjList*) malloc(n * sizeof(struct AdjList));
    for (int i = 0; i < n; ++i)
        grph->array[i].head = NULL;
    return grph;
}

void add_edge(graphe *grph, int src, int target, int weight)
{
    if (weight == 0)
        return;
    nodeAdjList *Node = new_nodeAdjList(target, weight);
    Node->next = grph->array[src].head;
    grph->array[src].head = Node;
}




/* Fonctions qui affiche les tableaux des accessibles et des distances */
void print_acc(int *tab, int size, int s){
    int i;
    printf("Sommets : \t \t");
    for (i=0; i < size; i++){
        printf("%d",i);
        printf(i<size-1?"\t":"\n");
        }
    printf("Acc. depuis %d : \t",s);
    for (i=0; i< size; i++){
        printf("%d",tab[i]);
        printf(i<size-1?"\t":"\n");
        }
}

void print_dist(int *tab, int size, int s){
    int i;
    printf("Sommets : \t \t");
    for (i=0; i < size; i++){
        printf("%d",i);
        printf(i<size-1?"\t":"\n");
        }
    printf("Dist. depuis %d : \t",s);
    for (i=0; i< size; i++){
        printf("%d",tab[i]);
        printf(i<size-1?"\t":"\n");
        }
}

/* Fonction qui affiche une liste d'adjacence */
void print_adjlist(struct graphe* grph)
{
    int v;
    for (v = 0; v < grph->vertices; v++) {
        nodeAdjList* temp = grph->array[v].head;
        printf("\n Liste d'adjacence de %d : \n head ", v);
        while (temp != NULL) {
            printf("-> (%d, %d)", temp->target, temp->weight);
            temp = temp->next;
        }
        printf("\n");
    }
}

/* Génération d'un graphe aléatoire, en stockant les poids des arêtes qu'on ajoute
dans un tableau n*n */
graphe * remplirgraphe(int n){
    graphe *grph = newgraph(n);
    int i,j,w,num,max;
    float v, taux;
    max = n * n;
    taux = 25.0;
    num = n / 10;
    while (num > 1) {
        num /= 5;
        taux /= 3.0;
  }
    taux /= 100.0;
    srand(time(NULL));
    for (i=0; i < n; i++){
        for (j=0; j < n; j++){
            v = (float) rand () / RAND_MAX;
            add_edge(grph,i,j,v < taux ? (int) (v * 100.) : 0);
        }
    }
    return grph;
    }


/* Ecrire le parcours en largeur et Dijkstra ici */


int main()
{
    graphe *grph = remplirgraphe(15);
    print_adjlist(grph);
    printf("\n \n");
    dijkstra_list(grph,0);
    printf("\n \n");
    accessibles_list(grph,0);

    return 0;
}
