#include <stdio.h>
#include <stdlib.h>
#include<time.h>

/* On ne prend que des graphes orientés: si il y a un arête de
i vers j, il n'y en a pas forcément de j vers i. */


#define MAX_NOEUD 15
#define INF 9999

typedef struct element {
    int valeur;
    struct element *suivant;
}element;


typedef struct file{
  element *debut;
  element *fin;
  int taille;
} file;

int is_empty_file(file *F){
    if (F->taille == 0 && F->debut == NULL && F->fin == NULL)
        return 1;
    else
        return 0;
}

file * newfile() {
   file *F = malloc(sizeof(*F));
   if (F == NULL) printf("Erreur d'allocation.");
   F->taille = 0;
   F->debut = F->fin = NULL;
   return(F);
}

void push(file *F, int s) {
    if (F == NULL) printf ("La file n'existe pas - On ne peut empiler.");
    element *e = malloc(sizeof(*e));
    if (e == NULL)
        printf("Erreur d'allocation");
    e->valeur = s;
    e->suivant = NULL;
    if (F->taille == 0){
        F->debut = F->fin = e;
    }
    else {
        F->fin->suivant = e;
        F->fin = e;
        }
    (F->taille)+=1;
}

void defiler(file *F) {
    element *e = malloc(sizeof(*e));
    if (F == NULL || F->taille == 0)printf("Erreur dépilement.");
        e = F->debut;
    if (F->taille == 1)
        F->debut = F->fin = NULL;
    else
        F->debut= F->debut->suivant;
   F->taille -= 1;
}

int take_first(file *F){
    if (is_empty_file(F) == 1){
        printf("La file est vide. Pas de première valeur.");
        return 0;
        }
    else
        return F->debut->valeur;
}

int take_last(file *F){
    if (is_empty_file(F) == 1){
        printf("La file est vide. Pas de première valeur.");
        return 0;
        }
    else
        return F->fin->valeur;
}

/* Affichage d'une file */
void affiche_file(file *F) {
   element *e;
   if (F == NULL) printf("Erreur; pas d'affichage possible. \n");
   e = F->debut;
   while (e != NULL) {
      printf("%d ", e->valeur);
      e = e->suivant;
   }
   printf("\n");
}



/* Fonctions qui affiche les tableaux des accessibles et des distances */
void print_acc(int *tab, int size, int s){
    int i;
    printf("Sommets : \t \t");
    for (i=0; i < size; i++){
        printf("%d",i);
        printf(i<size-1?"\t":"\n");
        }
    printf("Acc. depuis %d : \t",s);
    for (i=0; i< size; i++){
        printf("%d",tab[i]);
        printf(i<size-1?"\t":"\n");
        }
}

void print_dist(int *tab, int size, int s){
    int i;
    printf("Sommets : \t \t");
    for (i=0; i < size; i++){
        printf("%d",i);
        printf(i<size-1?"\t":"\n");
        }
    printf("Dist. depuis %d : \t",s);
    for (i=0; i< size; i++){
        printf("%d",tab[i]);
        printf(i<size-1?"\t":"\n");
        }
}


// Définition de la structure de graphe avec matrice d'adjacence //
typedef struct graphe{
    int vertices;
    int adj[MAX_NOEUD][MAX_NOEUD];
}graphe;


graphe * newgraph(int n){
    graphe *grph;
    grph = malloc(sizeof(*grph));
    if(grph == NULL)
        {
            fprintf(stderr, "Erreur : Probleme creation Graphe.\n");
            exit(EXIT_FAILURE);
        }
    grph->vertices = n;
    int i,j,w;
    float v;
    srand(time(NULL));
    for (i=0; i < MAX_NOEUD; i++){
        for (j=0; j < MAX_NOEUD; j++){
           grph->adj[i][j] = 0;
        }
    }
    return grph;
}

void display(graphe *grph){
    printf("Nombre de sommets : %d. \n",grph->vertices);
    printf("Matrice d'adjacence : \n");
    int i,j;
    for(i=0; i<MAX_NOEUD; i++){
        for(j=0; j<MAX_NOEUD; j++){
            printf("%d",grph->adj[i][j]);
            printf(j<MAX_NOEUD-1?"\t":"\n");
            }
        }
    }

void add_edge_weight(graphe *grph, int i, int j, int weight){
            grph->adj[i][j] += weight;
    }

void add_edge(graphe *grph, int i, int j){
            grph->adj[i][j] += 1;
    }


void remove_edge(graphe *grph, int i, int j){
    if (grph->adj[i][j] == 0){
        printf("Il n'y a pas d'arête à supprimer. ");
        }
    else{
        grph->adj[i][j] =0;
        printf("Arête de %d vers %d supprimée. \n",i,j);
        }
}


/* Fonction qui crée un graphe pondéré aléatoire, avec nombre de sommets
choisis */
graphe * remplirgraphe(int n){
    graphe *grph;
    grph = malloc(sizeof(*grph));
    grph->vertices = n;
    int i,j,w,num,max;
    float v, taux;
    max = n * n;
    taux = 25.0;
    num = n / 10;
    while (num > 1) {
        num /= 5;
        taux /= 3.0;
  }
    taux /= 100.0;
    srand(time(NULL));
    for (i=0; i < MAX_NOEUD; i++){
        for (j=0; j < MAX_NOEUD; j++){
            v = (float) rand () / RAND_MAX;
            grph->adj[i][j] = v < taux ? (int) (v * 100.) : 0;
        }
    }
    return grph;
    }



/* Ecrire le parcours en largeur ici. */



/* Fonction permettant de trouver le sommet à plus petite distance
parmis les sommets pas encore parcourus, sans utiliser de pile de priorité */
int minDistance(int dist[], int access[])
{
    int min = INF, min_index;
    int i;
    for (int i = 0; i < MAX_NOEUD; i++)
        if (access[i] == 0 && dist[i] <= min)
            min = dist[i], min_index = i;
    return min_index;
}


/* Ecrire l'algorithme de Dijkstra ici */






int main(){
    graphe *grph=remplirgraphe(MAX_NOEUD);
    display(grph);
    printf("\n \n");
    accessibles_mat(grph,2);
    printf("\n \n");
    dijkstra_mat(grph,2);
    return 0;
}
